## libkysdk-base 2.2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(kysdk-base)

include(CMakePackageConfigHelpers)

include_directories("${PROJECT_BINARY_DIR}")

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 11)

set (CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (CMAKE_SKIP_RPATH ON)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
    add_definitions(-Drelease)
    set(CMAKE_C_FLAGS "$ENV{CFLAGS} -O1 -Wall")
    set(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O1 -Wall")
elseif(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(CMAKE_C_FLAGS "$ENV{CFLAGS} -g -O0 -Wall")
    set(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -g -O0 -Wall")
endif()

message("Build Type: ${CMAKE_BUILD_TYPE}")

set (LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)

set (CMAKE_INSTALL_PREFIX /usr)
set (CMAKE_INSTALL_RPATH /usr/lib/${CMAKE_HOST_SYSTEM_PROCESSOR}-linux-gnu)

add_subdirectory(src)

=== src/CMakeLists.txt ===
include_directories(config)
include_directories(utils)
include_directories(log)
include_directories(timer)
include_directories(gsettings)

# add_subdirectory(communication)
add_subdirectory(config)
# add_subdirectory(debbuger)
add_subdirectory(log)
# add_subdirectory(process)
# add_subdirectory(thread)
add_subdirectory(timer)
add_subdirectory(utils)
# add_subdirectory(diagnostics)
add_subdirectory(gsettings)

=== src/config/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kysdk-config SHARED ${SOURCESCODE})
set_target_properties(kysdk-config PROPERTIES VERSION 2.0.0 SOVERSION 1)
add_executable(kyconf-test-struct test/test_structlist.c)
target_link_libraries(kyconf-test-struct kysdk-config kysdk-log pthread)

install(TARGETS kysdk-config
        DESTINATION ${CMAKE_INSTALL_RPATH})

install(FILES libkyconf.h
        DESTINATION include/kysdk/kysdk-base)

=== src/gsettings/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
include(FindPkgConfig)
pkg_check_modules(GTK3 REQUIRED gtk+-3.0 glib-2.0)
include_directories(${GTK3_INCLUDE_DIRS})

link_directories(${GTK3_LIBRARY_DIRS})
add_definitions(${GTK3_CFLAGS_OTHER})

add_library(kysdk-gsetting SHARED ${SOURCESCODE})
set_target_properties(kysdk-gsetting PROPERTIES VERSION 2.0.0 SOVERSION 1)

add_executable(test-kygsetting test/test-gsetting.c)
target_link_libraries(kysdk-gsetting ${GTK3_LIBRARIES})
target_link_libraries(test-kygsetting kysdk-gsetting)

install(TARGETS kysdk-gsetting
        DESTINATION ${CMAKE_INSTALL_RPATH})

install(FILES libkygsetting.h
        DESTINATION include/kysdk/kysdk-base)

=== src/log/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
include(CMakePackageConfigHelpers)
include(FindPkgConfig)
pkg_check_modules(DBus REQUIRED
                dbus-1)
include_directories(${DBus_INCLUDE_DIRS})
add_library(kysdk-log SHARED ${SOURCESCODE})
set_target_properties(kysdk-log PROPERTIES VERSION 2.0.0 SOVERSION 1)
add_executable(kylog-testlog test/test-log.c)
add_executable(kylog-testsetdir test/test-setdir.c)
add_executable(kylog-testpressure test/test-pressure.c)
add_executable(kylog-testautowrap test/test-autowrap.c)
find_library(SYSTEMD_LIB systemd)
find_library(DBUS_LIB dbus-1)
target_link_libraries(kysdk-log kysdk-config pthread ${SYSTEMD_LIB} ${DBUS_LIB})
target_link_libraries(kylog-testlog kysdk-log)
target_link_libraries(kylog-testsetdir kysdk-log)
target_link_libraries(kylog-testautowrap kysdk-log)
target_link_libraries(kylog-testpressure kysdk-log)

install(TARGETS kysdk-log
        DESTINATION ${CMAKE_INSTALL_RPATH})

install(FILES libkylog.h
        DESTINATION include/kysdk/kysdk-base)

install(FILES kylog-rotate-default
        DESTINATION /etc/kysdk/kysdk-base)

=== src/timer/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kysdk-timer SHARED ${SOURCESCODE})
set_target_properties(kysdk-timer PROPERTIES VERSION 2.0.0 SOVERSION 1)
add_executable(test-kytimer test/test-kytimer.c)
target_link_libraries(kysdk-timer pthread)
target_link_libraries(test-kytimer kysdk-timer)

install(TARGETS kysdk-timer
        DESTINATION ${CMAKE_INSTALL_RPATH})

install(FILES libkytimer.h
        DESTINATION include/kysdk/kysdk-base)

=== src/utils/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kyutils SHARED ${SOURCESCODE})
set_target_properties(kyutils PROPERTIES VERSION 2.0.0 SOVERSION 1)
include_directories(.)
install(TARGETS kyutils
        DESTINATION ${CMAKE_INSTALL_RPATH})
install(FILES sdkmarcos.h kerr.h cstring-extension.h kyutils.h
        DESTINATION include/kysdk/kysdk-base)
add_executable(test-utils sample/kyutils_sample.c)
target_link_libraries(test-utils kyutils)

add_subdirectory(data-structure)

=== src/utils/data-structure/CMakeLists.txt ===
aux_source_directory(linklist/skip_linklist SOURCESCODESTRUCT)
add_library(kydatastruct SHARED ${SOURCESCODESTRUCT})
set_target_properties(kydatastruct PROPERTIES VERSION 2.0.0 SOVERSION 1)
add_subdirectory(linklist)

include_directories(linklist)
include_directories(linklist/skip_linklist)

add_executable(test-delete linklist/skip_linklist/test/delete_test.c)
add_executable(test-insert linklist/skip_linklist/test/insert_test.c)
add_executable(test-search linklist/skip_linklist/test/search_test.c)
target_link_libraries(test-delete kydatastruct)
target_link_libraries(test-insert kydatastruct)
target_link_libraries(test-search kydatastruct)

install(TARGETS kydatastruct
        DESTINATION ${CMAKE_INSTALL_RPATH})

=== debian/changelog ===
libkysdk-base (2.2.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- xibowen <xibowen@kylinos.cn>  Wed, 16 Aug 2023 11:06:34 +0800

libkysdk-base (1.0.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1031344)

 -- KevinDuan <duankaiwen@ubuntukylin.com>  Tue, 14 Feb 2023 10:48:05 +0800

=== debian/control ===
Source: libkysdk-base
Section: libs
Priority: optional
Maintainer: kylin Team <team+kylin@tracker.debian.org>
Uploaders: KevinDuan <duankaiwen@ubuntukylin.com>, xibowen <xibowen@kylinos.cn>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libdbus-1-dev,
               libgtk-3-dev,
               libssl-dev,
               libsystemd-dev
Standards-Version: 4.6.1.0
Rules-Requires-Root: no
Homepage: https://gitee.com/openkylin/libkysdk-base
Vcs-Git: https://gitee.com/openkylin/libkysdk-base.git
Vcs-Browser: https://gitee.com/openkylin/libkysdk-base

Package: libkysdk-base
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Kylin SDK basic library
 libkysdk-base provides common functions in the
 process of program development, including log
 management, message communication, process
 daemon, thread management, timer, debugging and
 embedding, configuration file reading and writing, etc.
 This package is empty package.

Package: libkysdk-base-dev
Architecture: any
Section: libdevel
Depends: libkysdk-base ( = ${binary:Version}), libsystemd-dev, ${misc:Depends}
Description: development files for libkysdk-base
 libkysdk-base-dev provides common functions in the
 process of program development, including log
 management, message communication, process daemon, thread
 management, timer, debugging and embedding, configuration
 file reading and writing, etc.
 Contains development files for libkysdk-base.

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# override_dh_makeshlibs:
# 	dh_makeshlibs --no-scripts

=== debian/watch ===
version=4
https://gitee.com/openkylin/libkysdk-base/releases/ .*/libkysdk-base-(\d\S+)\.tar\.gz

## libkysdk-base 2.2.0.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,5 +12,5 @@
 # add_subdirectory(thread)
 add_subdirectory(timer)
 add_subdirectory(utils)
-# add_subdirectory(diagnostics)
+add_subdirectory(diagnostics)
 add_subdirectory(gsettings)

=== src/config/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 target_link_libraries(kyconf-test-struct kysdk-config kysdk-log pthread)
 
 install(TARGETS kysdk-config
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 install(FILES libkyconf.h
         DESTINATION include/kysdk/kysdk-base)

=== src/diagnostics/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(kydiagnostics LANGUAGES CXX)

set(DIAGNOSTICS_TOP_DIR ${CMAKE_CURRENT_LIST_DIR})
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

add_library(${PROJECT_NAME} SHARED)
include(GenerateExportHeader)
generate_export_header(kydiagnostics)
set_target_properties(kydiagnostics PROPERTIES VERSION 2.0.0 SOVERSION 1)

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -g)
target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_11)

find_package(PkgConfig REQUIRED)

pkg_check_modules(OPENSSL openssl)
target_include_directories(${PROJECT_NAME} PRIVATE ${OPENSSL_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${OPENSSL_LIBRARY_DIRS})
target_link_libraries(${PROJECT_NAME} PRIVATE ${OPENSSL_LIBRARIES})

pkg_check_modules(DBUS-1 dbus-1)
target_include_directories(${PROJECT_NAME} PRIVATE ${DBUS-1_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${DBUS-1_LIBRARY_DIRS})
target_link_libraries(${PROJECT_NAME} PRIVATE ${DBUS-1_LIBRARIES})


set(SRCS 
    "${DIAGNOSTICS_TOP_DIR}/libkydiagnostics.cpp"
    "${DIAGNOSTICS_TOP_DIR}/buriedpoint.cpp")

target_include_directories(${PROJECT_NAME} PRIVATE ${DIAGNOSTICS_TOP_DIR})
target_sources(${PROJECT_NAME} PRIVATE ${SRCS})

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
install(FILES
	libkydiagnostics.h
	${CMAKE_CURRENT_BINARY_DIR}/kydiagnostics_export.h
        DESTINATION include/kysdk/kysdk-base)

=== src/gsettings/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 target_link_libraries(test-kygsetting kysdk-gsetting)
 
 install(TARGETS kysdk-gsetting
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 install(FILES libkygsetting.h
         DESTINATION include/kysdk/kysdk-base)

=== src/log/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 target_link_libraries(kylog-testpressure kysdk-log)
 
 install(TARGETS kysdk-log
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 install(FILES libkylog.h
         DESTINATION include/kysdk/kysdk-base)

=== src/timer/test/Makefile ===
all:
	gcc -g -O0 -o test-kytimer test-kytimer.c -lkysdk-timer -lpthread

clean:
	rm demo

=== debian/changelog ===
libkysdk-base (2.2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix compile error on armhf and ppc64el.
  * d/control:
    - Add Multi-Arch.

 -- xibowen <xibowen@kylinos.cn>  Wed, 20 Sep 2023 10:25:52 +0800

## libkysdk-base 2.2.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(kysdk-base)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

include_directories("${PROJECT_BINARY_DIR}")

set (CMAKE_EXPORT_COMPILE_COMMANDS ON)
set (CMAKE_SKIP_RPATH ON)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

message("Build Type: ${CMAKE_BUILD_TYPE}")

set (LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
set (EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)

set (CMAKE_INSTALL_PREFIX /usr)

add_subdirectory(src)

=== src/timer/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 target_link_libraries(test-kytimer kysdk-timer)
 
 install(TARGETS kysdk-timer
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 install(FILES libkytimer.h
         DESTINATION include/kysdk/kysdk-base)

=== src/utils/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set_target_properties(kyutils PROPERTIES VERSION 2.0.0 SOVERSION 1)
 include_directories(.)
 install(TARGETS kyutils
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES sdkmarcos.h kerr.h cstring-extension.h kyutils.h
         DESTINATION include/kysdk/kysdk-base)
 add_executable(test-utils sample/kyutils_sample.c)

=== src/config/test/Makefile ===
LDFLAGS =
FILE=$(file)
CFLAGS=$(cflags)
CFLAGS += -g -O0 -std=gnu11 -Wall -DPWD=\"$(PWD)\" -I/usr/include/glib-2.0/glib/ -I../ -I../../utils/
CLIBS= -lpthread
CLIBS += $(clibs)

all:list

list:test_structlist.c ../configure.c ../structparse.c ../jsonparse.c ../gsettingsparse.c ../xmlparse.c
	gcc -o $(basename $<) $^ $(CFLAGS) $(CLIBS)

=== src/gsettings/test/Makefile ===
all:
	gcc -g -O0 -o test-gsetting test-gsetting.c

clean:
	rm demo

=== src/log/test/Makefile ===
all:
	gcc -o test-log test-log.c -g -O0 -I../ -I../../utils/ -L../lib -L../../config/lib/ -lkysdk-log -lkysdk-config -lpthread -lsystemd -Wl,-rpath=../lib:../../config/lib/
	gcc -o test-setdir test-setdir.c -g -O0 -I../ -I../../utils/ -L../lib -L../../config/lib/ -lkysdk-log -lkysdk-config -lpthread -lsystemd -Wl,-rpath=../lib:../../config/lib/
	gcc -o test-pressure test-pressure.c -g -O0 -I../ -I../../utils/ -L../lib -L../../config/lib/ -lkysdk-log -lkysdk-config -lpthread -lsystemd -Wl,-rpath=../lib:../../config/lib/

clean:
	-rm test-log test-setdir test-pressure

=== src/process/test/Makefile ===
CXXFLAGS += -g -O0 --std=c++11 -I../
VPATH=../:./

all:processdaemon.o
	g++ -o processdaemon $(CXXFLAGS) main.cpp ../processdaemon.cpp

.PHONY:processdaemon.o
processdaemon.o:processdaemon.cpp
	g++ -c -o processdaemon.o $(CXXFLAGS) ../processdaemon.cpp

=== src/utils/data-structure/CMakeLists.txt ===
--- 
+++ 
@@ -14,4 +14,4 @@
 target_link_libraries(test-search kydatastruct)
 
 install(TARGETS kydatastruct
-        DESTINATION ${CMAKE_INSTALL_RPATH})
+	DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/diagnostics/test/testburiedpoint/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(testburiedpoint LANGUAGES C)

set(BURIEDPOINT_TEST_TOP_DIR ${CMAKE_CURRENT_LIST_DIR})

add_executable(${PROJECT_NAME})

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -g)

find_package(PkgConfig REQUIRED)

pkg_check_modules(DIAGNOSTICS kysdk-diagnostics)
target_include_directories(${PROJECT_NAME} PRIVATE ${DIAGNOSTICS_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${DIAGNOSTICS_LIBRARY_DIRS})
target_link_libraries(${PROJECT_NAME} PRIVATE ${DIAGNOSTICS_LIBRARIES})

set(SRCS 
    "${BURIEDPOINT_TEST_TOP_DIR}/main.c")

target_include_directories(${PROJECT_NAME} PRIVATE ${BURIEDPOINT_TEST_TOP_DIR})
target_sources(${PROJECT_NAME} PRIVATE ${SRCS})

=== src/utils/data-structure/linklist/CMakeLists.txt ===
install(FILES listdata.h skip_linklist/skip_linklist.h
        DESTINATION include/kysdk/kysdk-base)

=== debian/changelog ===
libkysdk-base (2.2.0.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC 15. (Closes: #1097222)
  * Fix FTBFS with CMake 4. (Closes: #1113168)

 -- Adrian Bunk <bunk@debian.org>  Wed, 08 Oct 2025 22:06:58 +0300

libkysdk-base (2.2.0.2-1) unstable; urgency=medium

  * Fix ftbfs with gcc-14. (Closes: #1075178)
  * Merge fix-implicit-function-declaration.patch to upstream.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 23 Aug 2024 21:09:47 +0800

libkysdk-base (2.2.0.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with -Werror=implicit-function-declaration (Closes: #1066656).

 -- Andrey Rakhmatullin <wrar@debian.org>  Sat, 30 Mar 2024 12:44:02 +0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,9 @@
 Section: libs
 Priority: optional
 Maintainer: kylin Team <team+kylin@tracker.debian.org>
-Uploaders: KevinDuan <duankaiwen@ubuntukylin.com>, xibowen <xibowen@kylinos.cn>
+Uploaders: KevinDuan <duankaiwen@ubuntukylin.com>,
+           xibowen <xibowen@kylinos.cn>,
+           handsome_feng <jianfengli@ubuntukylin.com>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libdbus-1-dev,
@@ -24,12 +26,11 @@
  management, message communication, process
  daemon, thread management, timer, debugging and
  embedding, configuration file reading and writing, etc.
- This package is empty package.
 
 Package: libkysdk-base-dev
 Architecture: any
 Section: libdevel
-Depends: libkysdk-base ( = ${binary:Version}), libsystemd-dev, ${misc:Depends}
+Depends: libkysdk-base (= ${binary:Version}), libsystemd-dev, ${misc:Depends}
 Description: development files for libkysdk-base
  libkysdk-base-dev provides common functions in the
  process of program development, including log

=== debian/watch ===
version=4
https://gitee.com/openkylin/libkysdk-base/releases/ .*/libkysdk-base(-upstream)?-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## libkysdk-base 3.0.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.3)
+cmake_minimum_required(VERSION 3.5)
 
 project(kysdk-base)
 
@@ -19,6 +19,17 @@
 set (LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)
 set (EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
 
-set (CMAKE_INSTALL_PREFIX /usr)
+# 设置 CMAKE_INSTALL_LIBDIR 变量  
+if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "armv8l")
+        set(CMAKE_INSTALL_LIBDIR "/usr/lib/arm-linux-gnueabihf/")
+elseif(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
+        set(CMAKE_INSTALL_LIBDIR "/usr/lib/mips64el-linux-gnuabi64/")
+elseif(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "i686")
+        set(CMAKE_INSTALL_LIBDIR "/usr/lib/i386-linux-gnu/")
+else()
+        set(CMAKE_INSTALL_LIBDIR "/usr/lib/${CMAKE_HOST_SYSTEM_PROCESSOR}-linux-gnu/")
+endif()
+
+set (CMAKE_INSTALL_HEADER_DIR /usr/include/kysdk/kysdk-base)
 
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 include_directories(log)
 include_directories(timer)
 include_directories(gsettings)
+include_directories(conf2)
 
 # add_subdirectory(communication)
 add_subdirectory(config)
@@ -14,3 +15,4 @@
 add_subdirectory(utils)
 add_subdirectory(diagnostics)
 add_subdirectory(gsettings)
+add_subdirectory(conf2)

=== src/conf2/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)

pkg_check_modules(GLIB REQUIRED glib-2.0 gio-2.0 gio-unix-2.0)
include_directories(${GLIB_INCLUDE_DIRS})

pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
include_directories(${YAML_CPP_INCLUDE_DIRS})

set(CMAKE_AUTOMOC ON)
find_package(Qt6 COMPONENTS Core Sql REQUIRED)

# api
set(CONF2LIB  kyconf2)
set(CONF2LIBSRC api/libkysettings.c api/ksettingsschema.c)

add_library(${CONF2LIB} SHARED ${CONF2LIBSRC})
set_target_properties(${CONF2LIB} PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_libraries(${CONF2LIB} ${GLIB_LIBRARIES} ${GIO_LIBRARIES} -lsqlite3)
target_link_options(${CONF2LIB} PRIVATE "-Wl,-z,now")

# sync-config
set(SYNCSYSTEM conf2-sync-system)
set(SYNCSYSTEMSRC sync-config/conf2-sync-system.c sync-config/sync-dbus-server.c sync-config/gdbus/libsyncconfig.c)
add_executable(${SYNCSYSTEM} ${SYNCSYSTEMSRC})
target_link_libraries(${SYNCSYSTEM} ${GLIB_LIBRARIES} ${GIO_LIBRARIES} ${CONF2LIB} kylog)

set(SYNCSESSION conf2-sync-session)
set(SYNCSESSIONSRC sync-config/conf2-sync-session.c sync-config/sync-dbus-server.c sync-config/gdbus/libsyncconfig.c)
add_executable(${SYNCSESSION} ${SYNCSESSIONSRC})
target_link_libraries(${SYNCSESSION} ${GLIB_LIBRARIES} ${GIO_LIBRARIES} ${CONF2LIB} kylog)

# tool
set(CONF2TOOL kconf2)
add_executable(${CONF2TOOL} tools/kconf2-tool.c )
target_link_libraries(${CONF2TOOL} ${CONF2LIB})

#test
add_executable(kyconf2-test test/kyconf2-test.c)
target_link_libraries(kyconf2-test ${CONF2LIB})

#conf2-compile
set(CONF2COMPILE conf2-compile)
set(CONF2COMPILESRC conf2-compile/main.cpp conf2-compile/sqlitehelper.cpp conf2-compile/utils.cpp conf2-compile/yamlhelper.cpp)
add_executable(${CONF2COMPILE} ${CONF2COMPILESRC})
target_link_libraries(${CONF2COMPILE} Qt6::Core Qt6::Sql ${YAML_CPP_LIBRARIES})

# 安装库文件  
install(TARGETS
        ${CONF2LIB}
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(TARGETS
        ${CONF2TOOL}
        ${SYNCSYSTEM}
        ${SYNCSESSION}
        ${CONF2COMPILE}
        DESTINATION /usr/bin)

install(FILES
        api/libkysettings.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== src/config/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kyconf SHARED ${SOURCESCODE})
set_target_properties(kyconf PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_options(kyconf PRIVATE "-Wl,-z,now")
add_executable(kyconf-test-struct test/test_structlist.c)
target_link_libraries(kyconf-test-struct kyconf)

# 安装库文件  
install(TARGETS kyconf 
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES libkyconf.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== src/diagnostics/CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,10 @@
 project(kydiagnostics LANGUAGES CXX)
 
 set(DIAGNOSTICS_TOP_DIR ${CMAKE_CURRENT_LIST_DIR})
-set(CMAKE_CXX_VISIBILITY_PRESET hidden)
-set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 
 add_library(${PROJECT_NAME} SHARED)
-include(GenerateExportHeader)
-generate_export_header(kydiagnostics)
-set_target_properties(kydiagnostics PROPERTIES VERSION 2.0.0 SOVERSION 1)
+set_target_properties(kydiagnostics PROPERTIES VERSION 3.0.1 SOVERSION 1)
+target_link_options(kydiagnostics PRIVATE "-Wl,-z,now")
 
 target_compile_options(${PROJECT_NAME} PRIVATE -Wall -g)
 target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_11)
@@ -34,10 +31,10 @@
 target_include_directories(${PROJECT_NAME} PRIVATE ${DIAGNOSTICS_TOP_DIR})
 target_sources(${PROJECT_NAME} PRIVATE ${SRCS})
 
-install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})
+# 安装库文件  
+install(TARGETS ${PROJECT_NAME} 
+        DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
-target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
 install(FILES
-	libkydiagnostics.h
-	${CMAKE_CURRENT_BINARY_DIR}/kydiagnostics_export.h
-        DESTINATION include/kysdk/kysdk-base)
+        libkydiagnostics.h
+        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== src/gsettings/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
include(FindPkgConfig)
pkg_check_modules(GTK3 REQUIRED gtk+-3.0 glib-2.0)
include_directories(${GTK3_INCLUDE_DIRS})

link_directories(${GTK3_LIBRARY_DIRS})
add_definitions(${GTK3_CFLAGS_OTHER})

add_library(kygsetting SHARED ${SOURCESCODE})
set_target_properties(kygsetting PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_options(kygsetting PRIVATE "-Wl,-z,now")

add_executable(test-kygsetting test/test-gsetting.c)
target_link_libraries(kygsetting ${GTK3_LIBRARIES})
target_link_libraries(test-kygsetting kygsetting)

# 安装库文件  
install(TARGETS kygsetting 
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
        libkygsetting.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== src/log/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
include(CMakePackageConfigHelpers)
include(FindPkgConfig)
pkg_check_modules(DBus REQUIRED
                dbus-1)
include_directories(${DBus_INCLUDE_DIRS})
add_library(kylog SHARED ${SOURCESCODE})
set_target_properties(kylog PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_options(kylog PRIVATE "-Wl,-z,now")
add_executable(kylog-testlog test/test-log.c)
add_executable(kylog-testsetdir test/test-setdir.c)
add_executable(kylog-testpressure test/test-pressure.c)
add_executable(kylog-testautowrap test/test-autowrap.c)
find_library(SYSTEMD_LIB systemd)
find_library(DBUS_LIB dbus-1)
target_link_libraries(kylog kyconf pthread ${SYSTEMD_LIB} ${DBUS_LIB})
target_link_libraries(kylog-testlog kylog)
target_link_libraries(kylog-testsetdir kylog)
target_link_libraries(kylog-testautowrap kylog)
target_link_libraries(kylog-testpressure kylog)

# 安装库文件  
install(TARGETS kylog 
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
        libkylog.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

install(FILES kylog-rotate-default
        DESTINATION /etc/kysdk/kysdk-base)

=== src/timer/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kytimer SHARED ${SOURCESCODE})
set_target_properties(kytimer PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_options(kytimer PRIVATE "-Wl,-z,now")
add_executable(test-kytimer test/test-kytimer.c)
target_link_libraries(kytimer pthread)
target_link_libraries(test-kytimer kytimer)

# 安装库文件  
install(TARGETS kytimer 
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
        libkytimer.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== src/utils/CMakeLists.txt ===
aux_source_directory(. SOURCESCODE)
add_library(kyutils SHARED ${SOURCESCODE})
set_target_properties(kyutils PROPERTIES VERSION 3.0.1 SOVERSION 1)
target_link_options(kyutils PRIVATE "-Wl,-z,now")
include_directories(.)

add_executable(test-utils sample/kyutils_sample.c)
target_link_libraries(test-utils kyutils)

# 安装库文件  
install(TARGETS kyutils 
        DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
        sdkmarcos.h
        kerr.h
        cstring-extension.h
        kyutils.h
        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

add_subdirectory(data-structure)

=== src/utils/data-structure/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
 aux_source_directory(linklist/skip_linklist SOURCESCODESTRUCT)
 add_library(kydatastruct SHARED ${SOURCESCODESTRUCT})
-set_target_properties(kydatastruct PROPERTIES VERSION 2.0.0 SOVERSION 1)
-add_subdirectory(linklist)
+set_target_properties(kydatastruct PROPERTIES VERSION 3.0.1 SOVERSION 1)
+target_compile_options(kydatastruct PRIVATE "-fstack-protector-all")
+target_link_options(kydatastruct PRIVATE "-Wl,-z,now")
 
 include_directories(linklist)
 include_directories(linklist/skip_linklist)
@@ -13,5 +14,11 @@
 target_link_libraries(test-insert kydatastruct)
 target_link_libraries(test-search kydatastruct)
 
-install(TARGETS kydatastruct
-	DESTINATION ${CMAKE_INSTALL_LIBDIR})
+# 安装库文件  
+install(TARGETS kydatastruct 
+        DESTINATION ${CMAKE_INSTALL_LIBDIR})
+
+install(FILES
+        linklist/listdata.h
+        linklist/skip_linklist/skip_linklist.h
+        DESTINATION ${CMAKE_INSTALL_HEADER_DIR})

=== debian/changelog ===
libkysdk-base (3.0.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Add debian/upstream/metadata, update d/watch to version 5.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 26 Feb 2026 16:18:18 +0800

libkysdk-base (3.0.1.0-1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Update Build-Depends: add libglib2.0-dev, libsqlite3-dev,
      libyaml-cpp-dev, and qt6-base-dev (migrate to Qt6).
    - Bump Standards-Version to 4.7.1.
    - Update libkysdk-base dependencies: add python3:any.
    - Update libkysdk-base-dev dependencies: remove libsystemd-dev.
  * debian/rules:
    - Remove QT_SELECT=5 export.
    - Add override_dh_install to enable dh_installsystemd.
  * debian/patches: drop gcc-15.patch and cmake-4.patch which merged
    to upstream.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 29 Jan 2026 15:22:17 +0800

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	dh_installsystemd

=== debian/watch ===
Version: 5
Source: https://gitee.com/openkylin/libkysdk-base/releases/
Matching-Pattern: download/debian/(\d[\d\.]*)/libkysdk-base_\1.orig.tar.gz
